// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class ArraySetEnumeration extends Enumeration {

    // direkter Zugriff auf die Attribute zugehrigen Menge:
    private int currentSize;
    private Object[] array; 
    // Index, der die Menge durchluft:
    private int index;

    // die Attribute der zugehrigen Menge werden als Parameter bergeben:
    public ArraySetEnumeration(int currentSize, Object[] array) {
	this.currentSize = currentSize;
	this.array = array;
	index = 0;
    }

    public boolean hasMoreElements() {
	// genau dann, wenn index noch nicht currentSize erreicht hat:
	return index < currentSize;
    }

    public Object nextElement() {
	// weiterschalten:
	index++;
	// Inhalt des vorherr aktuellen Elements ausliefern:
	return array[index-1];
    }
}
