// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class OrderedListSetEnumeration extends Enumeration {
    // direkter Zugriff auf das Attribut list der zugehrigen Menge:
    private OrderedList list;

    // das Attribut list der zugehrigen Menge wird als Parameter bergeben:
    public OrderedListSetEnumeration(OrderedList list) {
	this.list = list;
    }

    public boolean hasMoreElements() {
	// genau dann, wenn Liste nicht leer ist:
	return list != null;
    }

    public Object nextElement() {
	// vor dem Weiterschalten Inhalt merken:
	Object o = list.getItem();
	// weiterschalten:
	list = list.getNext();
	// gemerkten Inhalt ausliefern:
	return o;
    }
}
