// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class MyInteger implements Comparable {

// Attribute (Datenstruktur):

    private int value;

// Konstruktor:

    public MyInteger(int value) {
        this.value = value;
    }

// sonstige Methoden:

    // liefert den int-Wert aus:
    public int getValue() {
	return value;
    }

    // vergleicht den Wert zweier MyIntegers:
    public int compareTo(Comparable c) {

        // Casting von Comparable auf MyInteger:
	MyInteger i = (MyInteger) c;

	if (value < i.value) 
	   return -1;

	if (value == i.value) 
	   return 0;
        
	return 1;
    }

    // vergleicht, ob zwei MyIntegers denselben Wert haben;
    // ueberschreibt entsprechende Methode aus Object:
    public boolean equals(Object o) {
	if (o.getClass() != this.getClass())
	   return false;

        // Casting von Object auf MyInteger:
	MyInteger i = (MyInteger) o;

	return i.value == value;
    }

    // Ausgabefunktion;
    // ueberschreibt entsprechende Methode aus Object:
    public String toString() {
	return "" + value;
    }
}
